module hamming(c,d,noerror,single,dbl,flip,badcode);
input [4:0]c;
input [7:0]d;
output noerror;
output [4:0]single;
output [14:0]dbl;
output [7:0]flip;
output [2:0]badcode;
wire [4:0]s;

assign s[0] = c[0] ^ d[6] ^ d[4] ^ d[3] ^ d[1] ^ d[0];
assign s[1] = c[1] ^ d[6] ^ d[5] ^ d[3] ^ d[2] ^ d[0];
assign s[2] = c[2] ^ d[7] ^ d[3] ^ d[2] ^ d[1];
assign s[3] = ~(c[3] ^ d[7] ^ d[6] ^ d[5] ^ d[4]);
assign s[4] = ~(c[4] ^ d[7] ^ d[5] ^ d[4] ^ d[2] ^ d[1] ^ d[0]);

// noerror: no error
// single: a single checkbit error
// flip: a single checkbit error and the fliped bits should be corrected
// dbl: double-bit error (cannot be corrected)
// badcode: other error

assign noerror = ~s[4] & ~s[3] & ~s[2] & ~s[1] & ~s[0];
assign single[0] = ~s[4] & ~s[3] & ~s[2] & ~s[1] & s[0];
assign single[1] = ~s[4] & ~s[3] & ~s[2] & s[1] & ~s[0];
assign dbl[0] = ~s[4] & ~s[3] & ~s[2] & s[1] & s[0];
assign single[2] = ~s[4] & ~s[3] & s[2] & ~s[1] & ~s[0];
assign dbl[1] = ~s[4] & ~s[3] & s[2] & ~s[1] & s[0];
assign dbl[2] = ~s[4] & ~s[3] & s[2] & s[1] & ~s[0];
assign flip[3] = ~s[4] & ~s[3] & s[2] & s[1] & s[0];
assign single[3] = ~s[4] & s[3] & ~s[2] & ~s[1] & ~s[0];
assign dbl[3] = ~s[4] & s[3] & ~s[2] & ~s[1] & s[0];
assign dbl[4] = ~s[4] & s[3] & ~s[2] & s[1] & ~s[0];
assign flip[6] = ~s[4] & s[3] & ~s[2] & s[1] & s[0];
assign dbl[5] = ~s[4] & s[3] & s[2] & ~s[1] & ~s[0];
assign badcode[0]=~s[4]& s[3] & s[2] & ~s[1] & s[0];
assign badcode[1]=~s[4]& s[3] & s[2] & s[1] & ~s[0];
assign dbl[6] = ~s[4] & s[3] & s[2] & s[1] & s[0];
assign single[4] = s[4] & ~s[3] & ~s[2] & ~s[1] & ~s[0];
assign dbl[7] = s[4] & ~s[3] & ~s[2] & ~s[1] & s[0];
assign dbl[8] = s[4] & ~s[3] & ~s[2] & s[1] & ~s[0];
assign flip[0] = s[4] & ~s[3] & ~s[2] & s[1] & s[0];
assign dbl[9] = s[4] & ~s[3] & s[2] & ~s[1] & ~s[0];
assign flip[1] = s[4] & ~s[3] & s[2] & ~s[1] & s[0];
assign flip[2] = s[4] & ~s[3] & s[2] & s[1] & ~s[0];
assign dbl[10] = s[4] & ~s[3] & s[2] & s[1] & s[0];
assign dbl[11] = s[4] & s[3] & ~s[2] & ~s[1] & ~s[0];
assign flip[4] = s[4] & s[3] & ~s[2] & ~s[1] & s[0];
assign flip[5] = s[4] & s[3] & ~s[2] & s[1] & ~s[0];
assign dbl[12] = s[4] & s[3] & ~s[2] & s[1] & s[0];
assign flip[7] = s[4] & s[3] & s[2] & ~s[1] & ~s[0];
assign dbl[13] = s[4] & s[3] & s[2] & ~s[1] & s[0];
assign dbl[14] = s[4] & s[3] & s[2] & s[1] & ~s[0];
assign badcode[2] = s[4] & s[3] & s[2] & s[1] & s[0];

endmodule
