module memory(rdaddr,rden,wraddr,data,wren,clk,out);
input [10:0]rdaddr;
input rden;
input [10:0]wraddr;
input [7:0]data;
input wren;
input clk;
output [7:0]out;
reg [7:0]p; //prepare to go out
reg [16383:0]m;//memory 2K*8
reg [13:0]base;

always@(posedge clk)
	begin
	if(rden)
		begin
		base = rdaddr<<3;
		p[0] = m[base];
		p[1] = m[base+1];
		p[2] = m[base+2];
		p[3] = m[base+3];
		p[4] = m[base+4];
		p[5] = m[base+5];
		p[6] = m[base+6];
		p[7] = m[base+7];
		end
	if(wren)
		begin
		base = wraddr<<3;
		m[base] = data[0];
		m[base+1] = data[1];
		m[base+2] = data[2];
		m[base+3] = data[3];
		m[base+4] = data[4];
		m[base+5] = data[5];
		m[base+6] = data[6];
		m[base+7] = data[7];
		end
	end
assign out = p;
endmodule
